/*
 * 3DS OUTSCALE API
 *
 * Welcome to the 3DS OUTSCALE's API documentation.<br /><br />  The 3DS OUTSCALE API enables you to manage your resources in the 3DS OUTSCALE Cloud. This documentation describes the different actions available along with code examples.<br /><br />  Note that the 3DS OUTSCALE Cloud is compatible with Amazon Web Services (AWS) APIs, but some resources have different names in AWS than in the 3DS OUTSCALE API. You can find a list of the differences [here](https://wiki.outscale.net/display/EN/3DS+OUTSCALE+APIs+Reference).<br /><br />  You can also manage your resources using the [Cockpit](https://wiki.outscale.net/display/EN/About+Cockpit) web interface.
 *
 * API version: 1.2
 * Contact: support@outscale.com
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package osc
// ReadConsumptionAccountRequest struct for ReadConsumptionAccountRequest
type ReadConsumptionAccountRequest struct {
	// If `true`, checks whether you have the required permissions to perform the action.
	DryRun bool `json:"DryRun,omitempty"`
	// The beginning of the time period, in ISO-8601 format with the date only (for example, `2017-06-14` or `2017-06-14T00:00:00Z`).
	FromDate string `json:"FromDate"`
	// The end of the time period, in ISO-8601 format with the date only (for example, `2017-06-30` or `2017-06-30T00:00:00Z`).
	ToDate string `json:"ToDate"`
}
